{****************************************************************}
{*                                                              *}
{*             Zeljko Cvijanovic - Teslic                       *}
{*              E-mail: cvzeljko@gmail.com                      *}
{*                  www.zeljus.com                              *}
{*                        2015                                  *}
{****************************************************************}
unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, SynEdit, vsComPort, Forms, Controls, Graphics,
  Dialogs, ExtCtrls, StdCtrls, ComCtrls, Grids, synaser;

type

  { TForm1 }
  TForm1 = class(TForm)
    Button1: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    StringGrid1: TStringGrid;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { private declarations }
    comport: TvsComPort;
    procedure OnStatusComPort(Sender: TObject; Reason: THookSerialReason; const Value: string);
    procedure onRxDataComPort(Sender: TObject);
  public
    { public declarations }
    IDPort: integer ;
    procedure ReadComPort(aDevice: string);

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.Button1Click(Sender: TObject);
begin
  ReadComPort(Edit1.Text);
end;



procedure TForm1.FormCreate(Sender: TObject);
begin
  IDPort:= 0;
end;

procedure TForm1.OnStatusComPort(Sender: TObject; Reason: THookSerialReason;
  const Value: string);
begin
  case Reason of
   HR_SerialClose : StatusBar1.SimpleText := 'Port ' + Value + ' closed';
   HR_Connect :   StatusBar1.SimpleText := 'Port ' + Value + ' connected';
   HR_CanRead :   StatusBar1.SimpleText := 'CanRead : ' + Value ;
   HR_CanWrite :  StatusBar1.SimpleText := 'CanWrite : ' + Value ;
   HR_ReadCount : StatusBar1.SimpleText := 'ReadCount : ' + Value ;
   HR_WriteCount : StatusBar1.SimpleText := 'WriteCount : ' + Value ;
   HR_Wait :  StatusBar1.SimpleText := 'Wait : ' + Value ;
  end;
end;

procedure TForm1.onRxDataComPort(Sender: TObject);
var
   Str: String;
begin
    if  (Sender as TvsComPort).Active then  begin
       Str := AnsiString((Sender as TvsComPort).ReadData);
       if length(Str) > 9 then
         StringGrid1.Cells[1, (Sender as TvsComPort).Tag] := Str;
    end else
     (Sender as TvsComPort).Free;
end;

procedure TForm1.ReadComPort(aDevice: string);
begin
  IDPort := IDPort + 1;
  comport:= TvsComPort.Create(nil);
  try
     comport.Name:= 'Measuring' + IntToStr(IDPort);
     comport.Tag:= IDPort;
     comport.Device:= aDevice;
     comport.RcvLineCRLF:= false;
     comport.OnStatus:= @OnStatusComPort;
     comport.OnRxData:= @onRxDataComPort;
     comport.Open;

     if comport.Active then begin
       StringGrid1.RowCount := IDPort + 1;
       StringGrid1.Rows[IDPort].Text:= comport.Name;
     end;
  finally
  //  comport.Close;
  //  comport.Free;
  end;
end;

end.

